<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<!-- Additional documentation for the optim package for Octave.

Copyright (C) Olaf Till <i7tiol@t-online.de>

You can redistribute this documentation and/or modify it under the terms
of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any
later version.

This documentation is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along
with this documentation; if not, see <http://www.gnu.org/licenses/>. -->
<!-- Created by GNU Texinfo 6.3, http://www.gnu.org/software/texinfo/ -->
<head>
<title>optim_doc: quadprog</title>

<meta name="description" content="optim_doc: quadprog">
<meta name="keywords" content="optim_doc: quadprog">
<meta name="resource-type" content="document">
<meta name="distribution" content="global">
<meta name="Generator" content="makeinfo">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="index.html#Top" rel="start" title="Top">
<link href="Function-index.html#Function-index" rel="index" title="Function index">
<link href="Compatibility-functions.html#Compatibility-functions" rel="up" title="Compatibility functions">
<link href="lsqnonlin.html#lsqnonlin" rel="next" title="lsqnonlin">
<link href="linprog.html#linprog" rel="prev" title="linprog">
<style type="text/css">
<!--
a.summary-letter {text-decoration: none}
blockquote.indentedblock {margin-right: 0em}
blockquote.smallindentedblock {margin-right: 0em; font-size: smaller}
blockquote.smallquotation {font-size: smaller}
div.display {margin-left: 3.2em}
div.example {margin-left: 3.2em}
div.lisp {margin-left: 3.2em}
div.smalldisplay {margin-left: 3.2em}
div.smallexample {margin-left: 3.2em}
div.smalllisp {margin-left: 3.2em}
kbd {font-style: oblique}
pre.display {font-family: inherit}
pre.format {font-family: inherit}
pre.menu-comment {font-family: serif}
pre.menu-preformatted {font-family: serif}
pre.smalldisplay {font-family: inherit; font-size: smaller}
pre.smallexample {font-size: smaller}
pre.smallformat {font-family: inherit; font-size: smaller}
pre.smalllisp {font-size: smaller}
span.nolinebreak {white-space: nowrap}
span.roman {font-family: initial; font-weight: normal}
span.sansserif {font-family: sans-serif; font-weight: normal}
ul.no-bullet {list-style: none}
-->
</style>


</head>

<body lang="en">
<a name="quadprog"></a>
<div class="header">
<p>
Next: <a href="lsqnonlin.html#lsqnonlin" accesskey="n" rel="next">lsqnonlin</a>, Previous: <a href="linprog.html#linprog" accesskey="p" rel="prev">linprog</a>, Up: <a href="Compatibility-functions.html#Compatibility-functions" accesskey="u" rel="up">Compatibility functions</a> &nbsp; [<a href="Function-index.html#Function-index" title="Index" rel="index">Index</a>]</p>
</div>
<hr>
<a name="Quadratic-programming"></a>
<h3 class="section">7.2 Quadratic programming</h3>
<a name="index-quadprog-7"></a>

<p>This function is similar to <code>qp</code> of core Octave.
</p>
<a name="XREFquadprog"></a><dl>
<dt><a name="index-quadprog"></a>Function File: <em></em> <strong>quadprog</strong> <em>(<var>H</var>, <var>f</var>)</em></dt>
<dt><a name="index-quadprog-1"></a>Function File: <em></em> <strong>quadprog</strong> <em>(<var>H</var>, <var>f</var>, <var>A</var>, <var>b</var>)</em></dt>
<dt><a name="index-quadprog-2"></a>Function File: <em></em> <strong>quadprog</strong> <em>(<var>H</var>, <var>f</var>, <var>A</var>, <var>b</var>, <var>Aeq</var>, <var>beq</var>)</em></dt>
<dt><a name="index-quadprog-3"></a>Function File: <em></em> <strong>quadprog</strong> <em>(<var>H</var>, <var>f</var>, <var>A</var>, <var>b</var>, <var>Aeq</var>, <var>beq</var>, <var>lb</var>, <var>ub</var>)</em></dt>
<dt><a name="index-quadprog-4"></a>Function File: <em></em> <strong>quadprog</strong> <em>(<var>H</var>, <var>f</var>, <var>A</var>, <var>b</var>, <var>Aeq</var>, <var>beq</var>, <var>lb</var>, <var>ub</var>, <var>x0</var>)</em></dt>
<dt><a name="index-quadprog-5"></a>Function File: <em></em> <strong>quadprog</strong> <em>(<var>H</var>, <var>f</var>, <var>A</var>, <var>b</var>, <var>Aeq</var>, <var>beq</var>, <var>lb</var>, <var>ub</var>, <var>x0</var>, <var>options</var>)</em></dt>
<dt><a name="index-quadprog-6"></a>Function File: <em>[<var>x</var>, <var>fval</var>, <var>exitflag</var>, <var>output</var>, <var>lambda</var>] =</em> <strong>quadprog</strong> <em>(&hellip;)</em></dt>
<dd><p>Solve the quadratic program
</p><div class="example">
<pre class="example">min 0.5 x'*H*x + x'*f
 x
</pre></div>
<p>subject to
</p><div class="example">
<pre class="example"><var>A</var>*<var>x</var> &lt;= <var>b</var>,
<var>Aeq</var>*<var>x</var> = <var>beq</var>,
<var>lb</var> &lt;= <var>x</var> &lt;= <var>ub</var>.
</pre></div>

<p>The initial guess <var>x0</var> and the constraint arguments (<var>A</var> and
<var>b</var>, <var>Aeq</var> and <var>beq</var>, <var>lb</var> and <var>ub</var>) can be set to
the empty matrix (<code>[]</code>) if not given.  If the initial guess
<var>x0</var> is feasible the algorithm is faster.
</p>
<p><var>options</var> can be set with <code>optimset</code>, currently the only
option is <code>MaxIter</code>, the maximum number of iterations (default:
200).
</p>
<p>Returned values:
</p>
<dl compact="compact">
<dt><var>x</var></dt>
<dd><p>Position of minimum.
</p>
</dd>
<dt><var>fval</var></dt>
<dd><p>Value at the minimum.
</p>
</dd>
<dt><var>exitflag</var></dt>
<dd><p>Status of solution:
</p>
<dl compact="compact">
<dt><code>0</code></dt>
<dd><p>Maximum number of iterations reached.
</p>
</dd>
<dt><code>-2</code></dt>
<dd><p>The problem is infeasible.
</p>
</dd>
<dt><code>-3</code></dt>
<dd><p>The problem is not convex and unbounded
</p>
</dd>
<dt><code>1</code></dt>
<dd><p>Global solution found.
</p>
</dd>
<dt><code>4</code></dt>
<dd><p>Local solution found.
</p></dd>
</dl>

</dd>
<dt><var>output</var></dt>
<dd><p>Structure with additional information, currently the only field is
<code>iterations</code>, the number of used iterations.
</p>
</dd>
<dt><var>lambda</var></dt>
<dd><p>Structure containing Lagrange multipliers corresponding to the
constraints. For equality constraints, the sign of the multipliers
is chosen to satisfy the equation
</p><div class="example">
<pre class="example">0.5 H * x + f + A' * lambda_inequ + Aeq' * lambda_equ = 0 .
</pre></div>
<p>If lower and upper bounds are equal, or so close to each other that
they are considered equal by the algorithm, only one of these
bounds is considered active when computing the solution, and a
positive lambda will be placed only at this bound.
</p>
</dd>
</dl>

<p>This function calls Octave&rsquo;s <code>__qp__</code> back-end algorithm internally.
</p></dd></dl>



<hr>
<div class="header">
<p>
Next: <a href="lsqnonlin.html#lsqnonlin" accesskey="n" rel="next">lsqnonlin</a>, Previous: <a href="linprog.html#linprog" accesskey="p" rel="prev">linprog</a>, Up: <a href="Compatibility-functions.html#Compatibility-functions" accesskey="u" rel="up">Compatibility functions</a> &nbsp; [<a href="Function-index.html#Function-index" title="Index" rel="index">Index</a>]</p>
</div>



</body>
</html>
